---
title: 'HTMLMediaElement: ended event'
slug: Web/API/HTMLMediaElement/ended_event
tags:
  - Audio
  - Event
  - HTML DOM
  - HTMLMediaElement
  - Media
  - Media Streams API
  - Reference
  - Video
  - Web Audio API
  - ended
---
<p>{{APIRef("HTMLMediaElement")}}</p>

<p><span class="seoSummary">The <code>ended</code> event is fired when playback or streaming has stopped because the end of the media was reached or because no further data is available. </span>This event occurs based upon {{domxref("HTMLMediaElement")}} ({{HTMLElement("audio")}} and {{HTMLElement("video")}}) fire <code>ended</code> when playback of the media reaches the end of the media.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Target</th>
   <td>Element</td>
  </tr>
  <tr>
   <th scope="row">Default Action</th>
   <td>None</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("GlobalEventHandlers.onended")}}</td>
  </tr>
  <tr>
   <th scope="row">Specification</th>
   <td><a class="external" href="http://www.whatwg.org/specs/web-apps/current-work/multipage/the-video-element.html#event-media-playing">HTML5 media</a></td>
  </tr>
 </tbody>
</table>

<ul>
</ul>

<div class="note">
<p>This event is also defined in <a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams</a> and <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></p>
</div>

<h2 id="Examples">Examples</h2>

<p>These examples add an event listener for the HTMLMediaElement's <code>ended</code> event, then post a message when that event handler has reacted to the event firing.</p>

<p>Using <code>addEventListener()</code>:</p>

<pre class="brush: js notranslate">const video = document.querySelector('video');

video.addEventListener('ended', (event) =&gt; {
  console.log('Video stopped either because 1) it was over, ' +
      'or 2) no further data is available.');
});</pre>

<p>Using the <code>onended</code> event handler property:</p>

<pre class="brush: js notranslate">const video = document.querySelector('video');

video.onended = (event) =&gt; {
  console.log('Video stopped either because 1) it was over, ' +
      'or 2) no further data is available.');
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "media.html#event-media-ended", "ended media event")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "embedded-content-0.html#event-media-ended", "ended media event")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLMediaElement.ended_event")}}</p>

<h2 id="Related_Events">Related Events</h2>

<ul>
 <li>{{domxref("HTMLMediaElement.playing_event", 'HTMLMediaElement: playing event')}}</li>
 <li>{{domxref("HTMLMediaElement.waiting_event", 'HTMLMediaElement: waiting event')}}</li>
 <li>{{domxref("HTMLMediaElement.seeking_event", 'HTMLMediaElement: seeking event')}}</li>
 <li>{{domxref("HTMLMediaElement.seeked_event", 'HTMLMediaElement: seeked event')}}</li>
 <li>{{domxref("HTMLMediaElement.ended_event", 'HTMLMediaElement: ended event')}}</li>
 <li>{{domxref("HTMLMediaElement.loadedmetadata_event", 'HTMLMediaElement: loadedmetadata event')}}</li>
 <li>{{domxref("HTMLMediaElement.loadeddata_event", 'HTMLMediaElement: loadeddata event')}}</li>
 <li>{{domxref("HTMLMediaElement.canplay_event", 'HTMLMediaElement: canplay event')}}</li>
 <li>{{domxref("HTMLMediaElement.canplaythrough_event", 'HTMLMediaElement: canplaythrough event')}}</li>
 <li>{{domxref("HTMLMediaElement.durationchange_event", 'HTMLMediaElement: durationchange event')}}</li>
 <li>{{domxref("HTMLMediaElement.timeupdate_event", 'HTMLMediaElement: timeupdate event')}}</li>
 <li>{{domxref("HTMLMediaElement.play_event", 'HTMLMediaElement: play event')}}</li>
 <li>{{domxref("HTMLMediaElement.pause_event", 'HTMLMediaElement: pause event')}}</li>
 <li>{{domxref("HTMLMediaElement.ratechange_event", 'HTMLMediaElement: ratechange event')}}</li>
 <li>{{domxref("HTMLMediaElement.volumechange_event", 'HTMLMediaElement: volumechange event')}}</li>
 <li>{{domxref("HTMLMediaElement.suspend_event", 'HTMLMediaElement: suspend event')}}</li>
 <li>{{domxref("HTMLMediaElement.emptied_event", 'HTMLMediaElement: emptied event')}}</li>
 <li>{{domxref("HTMLMediaElement.stalled_event", 'HTMLMediaElement: stalled event')}}</li>
</ul>

<h2 id="See_Also">See Also</h2>

<ul>
 <li>{{domxref("HTMLAudioElement")}}</li>
 <li>{{domxref("HTMLVideoElement")}}</li>
 <li>{{HTMLElement("audio")}}</li>
 <li>{{HTMLElement("video")}}</li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams</a>
  <ul>
   <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams: ended event</a><a href="/en-US/docs/Web/API/Media_Streams_API/ended_event">: ended event</a></li>
  </ul>
 </li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>
  <ul>
   <li><a href="/en-US/docs/Web/API/Web_Audio_API/ended_event">Web audio API: ended event</a></li>
  </ul>
 </li>
</ul>
